#include "mpi.h"
#include <unistd.h>
#include "assert.h"
#include <stdio.h>

int main(int argc, char* argv[]) {
  MPI_Init(&argc, &argv);

  int rank, size;
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  int sendmsg = 1;
  int recvmsg;

  MPI_Request request;

  MPI_Irecv(&recvmsg, 1, MPI_INTEGER, (rank-1) % size, 0, MPI_COMM_WORLD, &request);
  MPI_Send(&sendmsg, 1, MPI_INTEGER, (rank+1) % size, 0, MPI_COMM_WORLD);
  MPI_Wait(&request, MPI_STATUS_IGNORE);

  printf("Process %d done.\n", rank);
  assert(recvmsg == 1);

  MPI_Finalize();
  return 0;
}
